# Get club changelog events

`GET /api/club/{clubNumber}/changelog`

Retrieve normalized, paginated metric changes for a club. Events are ordered by comparison date and metric.

**Path parameters**

- `clubNumber` (string, required): Club number (e.g. 8-digit identifier)

**Query parameters**

- `fiscalYear` (string, optional): Toastmasters fiscal year (July-June). Defaults to the current fiscal year.
- `fiscalMonth` (integer, optional)
- `date` (date, optional)
- `startDate` (date, optional)
- `endDate` (date, optional)
- `category` (enum, optional) One of: `lifecycle`, `membership`, `education`, `status`, `renewals`.
- `metric` (string, optional)
- `limit` (integer, optional, default 1000): Maximum number of records to return
- `offset` (integer, optional, default 0): Number of records to skip
- `sortOrder` (enum, optional, default desc) One of: `asc`, `desc`.
- `view` (enum, optional): day: also return days, this page's events grouped by day with report glitches removed (a year-to-date count falling, or members falling outside the October/April removals) and memberRemoval on removal days. One of: `day`.

**Returns**

- `success` (boolean)
- `club_number` (string)
- `data` (array of objects)
  - `club_number` (string)
  - `club_name` (nullable string)
  - `district` (nullable string)
  - `division` (nullable string)
  - `area` (nullable string)
  - `comparison_date` (date)
  - `previous_date` (date)
  - `fiscal_year` (string)
  - `fiscal_month` (integer)
  - `category` (enum) One of: `lifecycle`, `membership`, `education`, `status`, `renewals`.
  - `metric` (string)
  - `change_type` (enum) One of: `increased`, `decreased`, `changed`, `club_added`, `club_removed`.
  - `old_value` (nullable string)
  - `new_value` (nullable string)
  - `old_value_numeric` (nullable number)
  - `new_value_numeric` (nullable number)
  - `delta_numeric` (nullable number)
- `days` (array of objects): view=day only: the page's events without report glitches, grouped by day.
  - `date` (date)
  - `events` (array of objects)
    - `club_number` (string)
    - `club_name` (nullable string)
    - `district` (nullable string)
    - `division` (nullable string)
    - `area` (nullable string)
    - `comparison_date` (date)
    - `previous_date` (date)
    - `fiscal_year` (string)
    - `fiscal_month` (integer)
    - `category` (enum) One of: `lifecycle`, `membership`, `education`, `status`, `renewals`.
    - `metric` (string)
    - `change_type` (enum) One of: `increased`, `decreased`, `changed`, `club_added`, `club_removed`.
    - `old_value` (nullable string)
    - `new_value` (nullable string)
    - `old_value_numeric` (nullable number)
    - `new_value_numeric` (nullable number)
    - `delta_numeric` (nullable number)
  - `memberRemoval` (nullable object): Set when active members fell during an October or April removal of unpaid members.
    - `period` (enum) One of: `October`, `April`.
    - `removed` (integer)
    - `from` (integer)
    - `to` (integer)
- `pagination` (object): Pagination returned by member-payments endpoints. total is the total matching records.
  - `total` (integer): Total matching records
  - `limit` (integer): Number of records per page
  - `offset` (integer): Number of records to skip
  - `has_more` (boolean): Whether there are more records available
- `filters` (object)
- `timestamp` (timestamp)

**Errors**

- `422`: Invalid changelog query
- `500`: Internal server error

**Example request**

```bash
curl "https://tm-api.devinpearson.me/api/club/113/changelog"
```

**Example response**

```json
{
  "success": true,
  "club_number": "113",
  "data": [
    {
      "club_number": "113",
      "club_name": "Example Toastmasters Club",
      "district": "74",
      "division": "A",
      "area": "01",
      "comparison_date": "2026-11-19",
      "previous_date": "2026-11-19",
      "fiscal_year": "2026-2027",
      "fiscal_month": 5,
      "category": "lifecycle",
      "metric": "string",
      "change_type": "increased",
      "old_value": "string",
      "new_value": "string",
      "old_value_numeric": 0,
      "new_value_numeric": 0,
      "delta_numeric": 0
    }
  ],
  "days": [
    {
      "date": "2026-11-19",
      "events": [
        {
          "club_number": "113",
          "club_name": "Example Toastmasters Club",
          "district": "74",
          "division": "A",
          "area": "01",
          "comparison_date": "2026-11-19",
          "previous_date": "2026-11-19",
          "fiscal_year": "2026-2027",
          "fiscal_month": 5,
          "category": "lifecycle",
          "metric": "string",
          "change_type": "increased",
          "old_value": "string",
          "new_value": "string",
          "old_value_numeric": 0,
          "new_value_numeric": 0,
          "delta_numeric": 0
        }
      ],
      "memberRemoval": {
        "period": "October",
        "removed": 0,
        "from": 0,
        "to": 0
      }
    }
  ],
  "pagination": {
    "total": 0,
    "limit": 0,
    "offset": 0,
    "has_more": true
  },
  "filters": {},
  "timestamp": "2026-11-19T04:30:00.000Z"
}
```
